<template>
  <dialog-card :title="$t('dialogs.export-analysis.title')" :actions="actions">
    <v-card-text class="keep-line-breaks">
      {{ $t('dialogs.export-analysis.info.info') }}
    </v-card-text>
    <v-form ref="form" lazy-validation>
      <v-text-field
        v-model="name" name="name"
        :label="$t('dialogs.export-analysis.label.filename')"
        :rules="[
          v => !!v || $t('dialogs.export-analysis.error.required'),
          v => (typeof v === 'string' && !!v.match(/^[0-9a-zA-Z\ \-\_\.\+]+$/))
            || $t('dialogs.export-analysis.error.characters') + '\ 0-9 a-z A-Z - _ + .',
        ]"
        required
      />
    </v-form>
  </dialog-card>
</template>

<script lang="ts">
import {
  Vue, Component, Prop,
} from 'vue-property-decorator';
import { trimAnalysisName } from '@/vuejs/components/utils/nav-tools';

@Component
export default class ExportDialog extends Vue {
  loading = false;

  name = '';

  get actions() {
    return {
      cancel: {
        text: this.$t('generic.action.cancel'),
        handle: this.close,
      },
      export: {
        text: this.$t('dialogs.export-analysis.action.export'),
        handle: this.export,
      },
    };
  }

  @Prop()
  filename!: string;

  mounted() {
    this.name = this.filename ? trimAnalysisName(this.filename) : '';
  }

  export(): string | boolean {
    if (this.name == null) {
      return false;
    }

    if (!this.name.match(/^[0-9a-zA-Z \-_]+$/)) {
      return false;
    }

    let name;

    if (this.name.endsWith('.dez')) {
      name = this.name;
    } else {
      name = `${this.name}.dez`;
    }

    return name;
  }

  close() {
    this.$emit('submit', false);
  }
}
</script>

<style scoped lang="scss">
.keep-line-breaks {
  white-space: pre-line
}
</style>
